/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*
	main.c   Cut MPEG Transport Stream files
	The code is somewhat ugly and unsafe, sorry! At least it is fast :-)
	(c) Jochen Puchalla 2015  <mail@puchalla-online.de>
*/

#include "cutmts.h"

#define VERSION "1.0"
#define YEAR "2015"

/* general buffersize */
#define BUFFER 32767

#define FRAMESIZE 192

#define VIDEOSIZE 640

	int debug=0;


	FILE *mtsfile, *timefile;
	long long filesize;
	long long inpoint, outpoint;
 	double startmins, endmins; /* minutes from inpoint and outpoint */
 	double startsecs, endsecs; /* seconds from inpoint and outpoint */
	double playsecs;
	int negstart=1, negend=1; /* start- and endpoint from end? */
	int totalmins, firstframe=0;
	int howlong=15; /* play how many PIDs of 0? */
	double totalms; /* total length in milliseconds */
	double startms; /* first time code in milliseconds */
	int a_b_used=0;
	double bitrate, msec; /* average bitrate and milliseconds */

	char *filename;
	char *forcedname;
	char *userin;
	char *userout;

	int mute=0, forced_file=0, overwrite=0, forced_prefix=0;
	int nonint=0;

// 	int card=1;
	signed int genre=-1;

	int hastable=0;
	unsigned char ttable[BUFFER];
	FILE *tblfile;
	char tblname[17] = "/tmp/tableXXXXXX";

	int fd1=-1;
	int fd2=-1;

	FILE *logfile;
	char logname[21] = "/tmp/mplayerlogXXXXXX";
	int fdlog=-1;

void exitseq(int foobar)
{
 	remove(logname);
	exit(foobar);  /* now really exit */
}

void usage(char *text)
{
	printf("\ncutmts  version %s  \n", VERSION);
	printf("\nUsage:  cutmts -i file.mts ");
	printf("\n               [-o outputprefix] [-q]\n");
	printf("\n  cutmts -i file.mts -o video         writes the output to video0001.mts, video0002.mts,...");
	printf("\n  cutmts -i file.mts -O video.mts     writes the output to video.mts");
	printf("\n  cutmts -I file.mts                  prints file information \n\n");
	if (text && text[0]!='\0') printf("%s\n\n",text);
}

void help(void)
{
	printf("\n\ncutmts  version %s  \n", VERSION);
	printf("\n        Seek with 1234567890\n");
	printf("        Mark beginning with 'a', go there with 'A'\n");
	printf("        Mark       end with 'b', go there with 'B'\n");
	printf("        Save selection with 's'.\n");
	printf("        increase playback length with 'M'.\n");
	printf("        decrease playback length with 'N'.\n");
	printf("        'o' turns on overwriting for next time.\n");
	printf("        'i' shows file info.\n\n");
	printf("        Replay with 'r'.\n");
// 	printf("        Write configuration file with 'S'.\n\n");
	printf("        Press 'q' to quit.\n\n");
	printf("        HINTS: 'w' is a shortcut for 'bsa'.\n");
	printf("               'W' is a shortcut for 'bta'.\n");
	return;
}


int framesize(unsigned char secondbyte,unsigned char thirdbyte,unsigned char fourthbyte)
{
	return FRAMESIZE;
}


int adaptionfield(unsigned char fourthbyte)
{
	unsigned char temp;

	temp=fourthbyte<<2;
	return temp>>7;
}


int containspayload(unsigned char eigthbyte)
{
	unsigned char temp;

	temp=eigthbyte<<3;
	return temp>>7;
}


int adaptionfieldlength(unsigned char ninethbyte)
{
	return ninethbyte;
}


int randomaccessindicator(unsigned char sixthbyte)
{
	unsigned char temp;

	temp=sixthbyte<<2;
	return temp>>7;
}


/* PCR = program clock ref */
int pcrflag(unsigned char tenthbyte)
{
	unsigned char temp;

	temp=tenthbyte<<3;
	return temp>>7;
}


int opcrflag(unsigned char sixthbyte)
{
	unsigned char temp;

	temp=sixthbyte<<4;
	return temp>>7;
}


int tspid(unsigned char sixthbyte,unsigned char seventhbyte)
{
	unsigned char temp;

	temp=sixthbyte<<3;
	sixthbyte=temp>>3;
	return sixthbyte*256+seventhbyte;
}


long timestamp(unsigned char firstbyte,unsigned char secondbyte,unsigned char thirdbyte,unsigned char fourthbyte)
{
// 	27 MHz +- 810 Hz clock
	return firstbyte*256*256*256+secondbyte*256*256+thirdbyte*256+fourthbyte;
}


/* get time code in milliseconds from next PCR frame */
double getms(long long seekpos)
{
	unsigned char a,b,c,d,e,f,g,h,afl,info;

	if(seekpos<=filesize/2)
	while (1)
	{
		seekpos=nextframe(seekpos);

		fseek(mtsfile, seekpos+4, SEEK_SET);
// 		printf("nf seekpos=%li \n",seekpos);
		e=fgetc(mtsfile);
		f=fgetc(mtsfile);
		g=fgetc(mtsfile);
		h=fgetc(mtsfile);

		if(adaptionfield(h) && e==71)
		{
// 			printf(" has adaption field ");
			afl=fgetc(mtsfile);
			info=fgetc(mtsfile);
			if(pcrflag(info) && afl > 8) // read PCR info
			{
// 				printf(" has PCR ");
				a=fgetc(mtsfile);
				b=fgetc(mtsfile);
				c=fgetc(mtsfile);
				d=fgetc(mtsfile);
// 				e=fgetc(mtsfile);
// 				f=fgetc(mtsfile);
// 				printf("of %.0f msec",msec);
				return (a*256*256*256+b*256*256+c*256+d)*2/90;
				break;
			}
		}
	}
	else
	while (1)
	{
		seekpos=prevframe(seekpos);

		fseek(mtsfile, seekpos+4, SEEK_SET);
// 		printf("pf seekpos=%li \n",seekpos);
		e=fgetc(mtsfile);
		f=fgetc(mtsfile);
		g=fgetc(mtsfile);
		h=fgetc(mtsfile);

		if(adaptionfield(h) && e==71)
		{
// 			printf(" has adaption field ");
			afl=fgetc(mtsfile);
			info=fgetc(mtsfile);
			if(pcrflag(info) && afl > 8) // read PCR info
			{
// 				printf(" has PCR ");
				a=fgetc(mtsfile);
				b=fgetc(mtsfile);
				c=fgetc(mtsfile);
				d=fgetc(mtsfile);
// 				e=fgetc(mtsfile);
// 				f=fgetc(mtsfile);
				return (a*256*256*256+b*256*256+c*256+d)*2/90;
// 				printf("of %.0f msec",msec);
				break;
			}
		}
	}


// 	printf(" found PCR at %li bytes\n",seekpos);
	return 0;
}


/* find next PID of 0 */
long long nextpid0(long long seekpos)
{
	unsigned char f,g;
	int pid;

	seekpos=nextframe(seekpos);
	if (seekpos+8>filesize) return filesize;

	fseek(mtsfile, seekpos+5, SEEK_SET);
//	printf("seekpos=%li \n",seekpos);

	f=fgetc(mtsfile);
	g=fgetc(mtsfile);

	pid=tspid(f,g);

	while(pid!=0)
	{
		seekpos=nextframe(seekpos);
		if (seekpos+8>filesize) return filesize;
		fseek(mtsfile, seekpos+5, SEEK_SET);

		f=fgetc(mtsfile);
		g=fgetc(mtsfile);

		pid=tspid(f,g);
	}

// 	printf(" found PID=0 at %li bytes\n",seekpos);
	return seekpos;
}


/* find previous PID of 0 */
long long prevpid0(long long seekpos)
{
	unsigned char f,g;
	int pid;

	seekpos=prevframe(seekpos);

	fseek(mtsfile, seekpos+5, SEEK_SET);
//	printf("seekpos=%li \n",seekpos);

	f=fgetc(mtsfile);
	g=fgetc(mtsfile);

	pid=tspid(f,g);

	while(pid!=0)
	{
		seekpos=prevframe(seekpos);
		fseek(mtsfile, seekpos+5, SEEK_SET);

		f=fgetc(mtsfile);
		g=fgetc(mtsfile);

		pid=tspid(f,g);
	}

// 	printf(" found PID=0 at %li bytes\n",seekpos);
	return seekpos;
}


/* seek x times PID of 0  */
long long nextxpid0(long long seekpos,int x)
{
	int i;

	for (i=0;i<x;i++){seekpos=nextpid0(seekpos);}

	return seekpos;
}


/* seek x times PID of 0 backwards */
long long prevxpid0(long long seekpos,int x)
{
	int i;

	for (i=0;i<x;i++){seekpos=prevpid0(seekpos);}

	return seekpos;
}


/* find next frame at seekpos */
long long nextframe(long long seekpos)
{
	long long oldseekpos=seekpos;   /* remember seekpos */
	unsigned char a,b,c,d,e,f,g,h;
	int pid;

	if (seekpos+8>filesize) return filesize;

	fseek(mtsfile, seekpos+4, SEEK_SET);
//	printf("seekpos=%li \n",seekpos);

	/* if seekpos is a header and framesize is valid, jump to next header via framesize, else move on one byte */
	e=fgetc(mtsfile); // header sync
	if (e==71)
	{
		seekpos=seekpos+FRAMESIZE;
// 		printf("seekpos=%li \n",seekpos);
	}
	else seekpos=oldseekpos+1;

	/* find next possible header, start right at seekpos */
	fseek(mtsfile, seekpos, SEEK_SET);

	while(1)           /* loop till break */
	{
		if (seekpos+8>=filesize) break;
		fseek(mtsfile, seekpos+4, SEEK_SET);
		e=fgetc(mtsfile);
		if (e==71)
		{
			f=fgetc(mtsfile);
			g=fgetc(mtsfile);
			pid=tspid(f,g);
			break;
// 			printf("seekpos=%li \n",seekpos);
		}
		seekpos++;
 		printf(".");
// 		printf("nextframe seeking at %li \n",seekpos);
	}

// 	printf(" pid=%i\n",pid);

// 	printf(" timestamp=%li \n",timestamp(a,b,c,d));
//	printf("seekpos1=%li\n",seekpos);

	/* also check next frame if possible */
	if (seekpos+FRAMESIZE+8<filesize)
	{
		fseek(mtsfile, seekpos+FRAMESIZE+4, SEEK_SET);
		e=fgetc(mtsfile);
		if (e==71) ;
		else seekpos=nextframe(seekpos+1);
	}

// 	printf(" nextframe seekpos=%li\n",seekpos);
	return seekpos;
}


/* find previous frame at seekpos */
long long prevframe(long long seekpos)
{
	long long oldseekpos=seekpos;   /* remember seekpos */
	long long nextheaderpos;
	unsigned char a,b,c,d,e,f,g,h;
	int pid;

	if (seekpos<firstframe) seekpos=firstframe;

	/* find next header, start right at seekpos */
	nextheaderpos=nextframe(seekpos);
	if (seekpos+FRAMESIZE==nextheaderpos) seekpos=seekpos-FRAMESIZE; /* doing the easy case first saves time */
//  	printf(" prevframe seekpos=%li \n",seekpos);
	if (seekpos<firstframe) {seekpos=firstframe; return seekpos;}

	/* rewind to previous header and check if nextheader is more than framesize bytes further */
	while(1)           /* loop till break */
	{
		if (seekpos<firstframe) break;
		fseek(mtsfile, seekpos+4, SEEK_SET);
		e=fgetc(mtsfile);
		if (e==71)
		{
			f=fgetc(mtsfile);
			g=fgetc(mtsfile);
			pid=tspid(f,g);
			if (seekpos+FRAMESIZE<=nextframe(seekpos)) break;     /* previous frame found */
		}
		seekpos--;
//  		printf(".");
// 		printf("prevframe seeking at %li \n",seekpos);
	}

// 	printf(" pid=%i\n",pid);

	if (seekpos<firstframe) seekpos=firstframe;
// 	printf("prevframe seekpos found at %li \n",seekpos);
	return seekpos;
}


/* skip x seconds  */
long long skipsecs(long long seekpos,int x)
{
	int i;
	long seekms,playms;

	seekms=playms=getms(seekpos);
	while(seekms < playms+x*1000 && seekms < getms(filesize))
	{
		seekpos=nextpid0(seekpos);
		seekms=getms(seekpos);
	}

	return seekpos;
}


/* rewind x seconds  */
long long rwdsecs(long long seekpos,int x)
{
	int i;
	long seekms,playms;

	seekms=playms=getms(seekpos);
	while(seekms > playms-x*1000 && seekms > getms(0))
	{
		seekpos=prevpid0(seekpos);
		seekms=getms(seekpos);
	}

	return seekpos;
}


/* This function plays at the current position */
void playsel(long long playpos)
{
// return;
	long long bytesin;
	long playsize;
// 	long pos;
	double percent;
	FILE *outfile;
	char command[1023];
	char playname[16] = "/tmp/playXXXXXX";
	static char prev_playname[16] = "";
	int fd=-1;
	int i=0,pid,a,b,c,d,e,f,g,h,afl,info;

	playsize=nextxpid0(playpos,howlong)-playpos;

	if (prev_playname[0] != 0) {
		// printf("remove file %s\n", prev_playname); /* debug */
		remove(prev_playname); /* delete tempfile */
	}

	if (playpos < firstframe)
	{
		playsize=playsize-(firstframe-playpos);
		playpos=firstframe;
	}
	if (playpos > filesize) playpos=filesize;
	if ((fd = mkstemp(playname)) == -1 || (NULL== (outfile = fdopen(fd, "w+b"))) )
	{
		perror("\ncutmts: failed writing temporary mts in /tmp");exitseq(9);
	} else {
		strncpy(prev_playname, playname, 16);
	}

	/* COPY FIRST 4 FRAMES HERE */
	fseek(mtsfile, 0, SEEK_SET);
// 	for (bytesin=0 ; bytesin < 768 ; bytesin++) fputc(getc(mtsfile),outfile);

	/* COPY OTHER FRAMES HERE */
	fseek(mtsfile, playpos, SEEK_SET);
	for (bytesin=0; bytesin < playsize; bytesin++) fputc(getc(mtsfile),outfile);
	fclose(outfile);

	snprintf(command,1022," %s %s %s %s %s","mplayer -vf scale=640:-2 -msglevel all=7 ",playname,">",logname,"2>&1 &");
// 	printf("%s\n",command); /* debug */
 	if (!mute) system(command);  /* play mts excerpt */

	playsecs=(getms(playpos)-startms)/(double)1000;
	percent=100*(double)playpos/(double)filesize;
 	printf("  playing at %.1f of %.1f seconds (%.0f %%",playsecs,totalms/1000,percent);

	if (playpos >= inpoint)
	printf(")\n");
	else
	printf(", before startpoint!)\n");

// 	if (!mute) { usleep(500000); } /* wait some time to start playing the file */
//  	remove(playname); /* delete tempfile */

}


/* This function reads the configuration file */
void readconf(void)
{
	FILE *conffile;
	long confsize=0,pos=0;
	unsigned char conf[BUFFER];
	char filename1[8191];

	snprintf(filename1,8190,"%s/%s",getenv("HOME"),".cutmtsrc");      /* get name of conffile */
	if (NULL == (conffile = fopen(filename1,"rb"))) return;      /* check for conffile */
	fseek(conffile, 0, SEEK_END);
	confsize=ftell(conffile);         /* size of conffile */

	/* read conffile into buffer: */
	fseek(conffile, 0, SEEK_SET);
	for (pos=0 ; pos<BUFFER && pos<confsize ; pos++) conf[pos]=fgetc(conffile);
	fclose(conffile);

	pos=0;        /* reset pos */
	return;
}


/* This function plays the file at program start only */
void playfirst(long long playpos)
{
	printf("\n1 <- 5 seeks backward");
	printf("\n6 -> 0 seeks forward");
// 	printf("\n ,  .  rewinds/skips one frame");
	printf("\n     a sets startpoint, A goes there");
	printf("\n     b sets endpoint, B goes there");
	printf("\n     s saves");
	printf("\n     Press 'h' for more help\n");
	printf("\n[1..0,r,a,b,s,q] >  ");
 	playsel(playpos);
}


/* This function saves the selection non-interactively */
void savesel(char *prefix)
{
	char *outname=malloc(8191);
	int number=1;
	long long bytesin=0,savepos;
	int a;
	FILE *fp;
	FILE *outfile;
	char command[1023];

	/* outname = prefix number . suffix */
	snprintf(outname,8190, "%s%04u.mts",prefix,number);

	printf("  saving...");
// 	printf(" to %s ",outname);

	if (inpoint > filesize)
	{
		if (nonint==1)
		{
			fprintf(stdout,"  cutmts: startpoint (%.1f s) must be before end of file (%.1f s)!  \n",(getms(inpoint)-startms)/1000,totalms/1000);
			return;
		}
		else
		{
			printf("  ERROR: startpoint (%.1f s) must be before end of file (%.1f s)!  \n",(getms(inpoint)-startms)/1000,totalms/1000);
			return;
		}
	}
	if (inpoint < firstframe)
	{
		if (nonint==1)
		{
			fprintf(stdout,"  cutmts: setting startpoint (%.1f s) to beginning of file (0 s)!  \n",(getms(inpoint)-startms)/1000);
			inpoint=firstframe;
			return;
		}
		else
		{
			printf("  WARNING: setting startpoint (%.1f s) to beginning of file (0 s)!  \n",(getms(inpoint)-startms)/1000);
			inpoint=firstframe;
		}
	}
	if (outpoint > filesize)
	{
		if (nonint==1)
		{
// 			printf("%lu %lu",outpoint,filesize);
			fprintf(stdout,"  cutmts: setting endpoint (%.1f s) to end of file (%.1f s)!  \n",(getms(outpoint)-startms)/1000,totalms/1000);
// 			return;
		}
		else
		{
			printf("  WARNING: setting endpoint (%.1f s) to end of file (%.1f s)!  \n",(getms(outpoint)-startms)/1000,totalms/1000);
		}
		outpoint=filesize;
	}
	if (outpoint <= inpoint)
	{
		if (nonint==1)
		{
			fprintf(stdout,"  cutmts: endpoint (%.1f s) must be after startpoint (%.1f s)!  \n",(getms(outpoint)-startms)/1000,(getms(inpoint)-startms)/1000);
			return;
		}
		else
		{
			printf("  ERROR: endpoint (%.1f s) must be after startpoint (%.1f s)!  \n",(getms(outpoint)-startms)/1000,(getms(inpoint)-startms)/1000);
			return;
		}
	}

		/* if file exists, increment number */
		fp = fopen(outname,"r");
		while(fp != NULL) /* test if file exists */
		{
			number++;
			fclose(fp);
			if (number>9999) usage("9999 files written. Please choose another prefix via '-o prefix.'");
			snprintf(outname,8190, "%s%04u.mts",prefix,number);
			fp = fopen(outname,"r");
		}
		number=number-overwrite; /* step one number back in case of overwrite mode */
		if (number==0) number=1;
		snprintf(outname,8190, "%s%04u.mts",prefix,number);

	/* forced output file name used? */
	if (forced_file==1) snprintf (outname, 8190, forcedname);

	/* open outfile */
	if (NULL== (outfile = fopen(outname,"wb"))){perror("\ncutmts: cannot not write output file! read-only filesystem?");exitseq(10);}

	/* COPY FIRST 4 FRAMES HERE */
//  	fseek(mtsfile, 0, SEEK_SET); for (bytesin=0 ; bytesin < 768 ; bytesin++) fputc(getc(mtsfile),outfile);

	/* COPY DATA HERE */
	fseek(mtsfile, inpoint, SEEK_SET);
	for (bytesin=0 ; bytesin < outpoint-inpoint ; bytesin++)
	{
 		fputc(getc(mtsfile),outfile);
	}

	printf("  saved %.1f s - %.1f s to '%s'.  \n",getms(inpoint)/1000,getms(outpoint)/1000,outname);

	overwrite=0;
	free(outname);
	fclose(outfile);
	return;
}

/* ################### KEY PRESS ######################## */

static struct termios  current,  /* new terminal settings             */
                       initial;  /* initial state for restoring later */

/* Restore term-settings to those saved when term_init was called */
void  term_restore  (void)  {
  tcsetattr(0, TCSANOW, &initial);
}  /* term_restore */

/* Clean up terminal; called on exit */
void  term_exit  ()  {
	term_restore();
	printf("\n\nbugreports to mail@puchalla-online.de\n\n");
	exitseq(0);
}	/* term_exit */

/* Will be called when ctrl-z is pressed, this correctly handles the terminal */
void  term_ctrlz  ()  {
	signal(SIGTSTP, term_ctrlz);
	term_restore();
	kill(getpid(), SIGSTOP);
}  /* term_ctrlz */

/* Will be called when application is continued after having been stopped */
void  term_cont  ()  {
	signal(SIGCONT, term_cont);
	tcsetattr(0, TCSANOW, &current);
}  /* term_cont */

/* Needs to be called to initialize the terminal */
void  term_init  (void)  {
	/* if stdin isn't a terminal this fails. But    */
	/* then so does tcsetattr so it doesn't matter. */

	tcgetattr(0, &initial);
	current = initial;                      /* Save a copy to work with later  */
	signal(SIGINT,  term_exit);             /* We _must_ clean up when we exit */
	signal(SIGQUIT, term_exit);
	signal(SIGTSTP, term_ctrlz);            /* Ctrl-Z must also be handled     */
	signal(SIGCONT, term_cont);
	//atexit(term_exit);
}	/* term_init */

/* Set character-by-character input mode */

void  term_character  (void)  {
	/* One or more characters are sufficient to cause a read to return */
	current.c_cc[VMIN]   = 1;
	current.c_cc[VTIME]  = 0;  /* No timeout; read forever until ready */
	current.c_lflag     &= ~ICANON;           /* Line-by-line mode off */
	tcsetattr(0, TCSANOW, &current);
}  /* term_character */

/* Return to line-by-line input mode */
void  term_line  (void)  {
	current.c_cc[VEOF]  = 4;
	current.c_lflag    |= ICANON;
	tcsetattr(0, TCSANOW, &current);
}  /* term_line */

/* Key pressed ? */
int  kbhit  (void)  {
	struct timeval  tv;
	fd_set          read_fd;

	/* Do not wait at all, not even a microsecond */
	tv.tv_sec  = 0;
	tv.tv_usec = 0;

	/* Must be done first to initialize read_fd */
	FD_ZERO(&read_fd);

	/* Makes select() ask if input is ready;  0 is file descriptor for stdin */
	FD_SET(0, &read_fd);

	/* The first parameter is the number of the largest fd to check + 1 */
	if (select(1, &read_fd,
		NULL,         /* No writes        */
		NULL,         /* No exceptions    */
		&tv)  == -1)
	return(0);                 /* an error occured */

	/* read_fd now holds a bit map of files that are readable. */
	/* We test the entry for the standard input (file 0).      */
	return(FD_ISSET(0, &read_fd)  ?  1  :  0);
}

/* ------------------------------------------------------------------------- */


/* This function seeks a time from START */
long long seekfrombeg(double m, double s)
{
	long long pos=0;
	double starttime=getms(0);


	fseek(mtsfile, 0, SEEK_SET);
	while(1)                              /* loop till break */
	{
		if (getms(pos)-starttime>=(m*60+s)*1000) break;       /* inpoint reached */
		if (pos>=filesize)                    /* start of file reached */
		{
			printf("  WARNING: end of file reached!  \n");
			pos=filesize;
			break;
		}
		pos=nextpid0(pos);
	}
// 	printf(" frombeg %.2f %.2f %lu \n",m,s,pos);
	return pos;
}


/* This function seeks a time from EOF */
long long seekfromend(double m, double s)
{
	long long pos=filesize;
	double endtime=getms(filesize);

	fseek(mtsfile, filesize, SEEK_SET);
	while(1)                              /* loop till break */
	{
		if (endtime-getms(pos)>=(m*60+s)*1000) break;       /* inpoint reached */
		if (pos<=0)                    /* start of file reached */
		{
			printf("  WARNING: beginning of file reached!  \n");
			pos=0;
			break;
		}
		pos=prevpid0(pos);
	}
// 	printf(" fromend %.2f %.2f %lu \n",m,s,pos);
	return pos;
}


/* This function copies by counting frames */
void cutexact(char *prefix)
{
	unsigned char a,b,c,d,e;
	long double time=0;
	long long pos;


	/* first look for inpoint */

//	printf("  seeking startpoint");
	if (negstart<0)
	{
		printf("  seeking startpoint backwards... (slow!)\n");
		inpoint=seekfromend(startmins,startsecs);
	}
	else
	{
		fseek(mtsfile, 0, SEEK_SET);
		while(1)                              /* loop till break */
		{
			if (time>=startmins*60+startsecs) break;       /* inpoint reached */
			if (pos>=filesize) return;                     /* EOF reached */
			a=fgetc(mtsfile); pos++;
			if (a==255)
			{
				b=fgetc(mtsfile);
				c=fgetc(mtsfile);
				d=fgetc(mtsfile);
//				if (isheader(b,c,d)==1 && framesize(b,c,d)!=1)              /* next frame found */
// 				if (is_header(b,c,d))     /* next frame found */
				{
//					printf("found header\n");
// 					fseek(mtsfile, pos-1+framesize(b,c,d), SEEK_SET);    /* skip framesize bytes */
// 					pos=pos-1+framesize(b,c,d);                          /* adjust pos to actual SEEK_SET */
				}
// 				else fseek(mtsfile, pos, SEEK_SET);    /* rewind to next byte for if (a==255) */
			}
		}
		inpoint=pos;
	}
// 	printf("  inpoint=%lu",inpoint);

	/* inpoint reached, now search for outpoint */

//	printf("  seeking endpoint");
	pos=0;
	time=0;
	if (negend<0)
	{
		printf("  seeking endpoint backwards... (slow!)\n");
		outpoint=seekfromend(endmins,endsecs);
	}
	else
	{
		while(1)                              /* loop till break */
		{
			/* pos must point to end of header in case next if() is true */
			if (time>=endmins*60+endsecs) break;       /* outpoint reached */
			if (pos>=filesize) break;                  /* EOF reached */
			a=fgetc(mtsfile); pos++;
			if (a==255)
			{
				b=fgetc(mtsfile);
				c=fgetc(mtsfile);
				d=fgetc(mtsfile);
				e=fgetc(mtsfile);
				if (e==71)     /* next frame found */
				{
					fseek(mtsfile, pos-1+framesize(b,c,d), SEEK_SET);    /* skip framesize bytes */
					pos=pos-1+framesize(b,c,d);                          /* adjust pos to actual SEEK_SET */
				}
				else fseek(mtsfile, pos, SEEK_SET);    /* rewind to next byte for if (a==255) */
			}
		}
		outpoint=pos;
		if (outpoint>filesize) outpoint=filesize;
	}

	/* outpoint reached, now write file */

//	printf("  saving selection...\n");
	savesel(prefix);
//	printf("%u %u %u %u",startsecs,endsecs,inpoint,outpoint);
	startsecs=startmins=endsecs=endmins=0;
	return;
}


/* This function writes a timetable when -a and -b is used */
void writetable()
{
	int fd=-1;

	if ((fd = mkstemp(tblname)) == -1 || (NULL== (tblfile = fdopen(fd, "w+b"))) )
	{
		perror("\ncutmts: failed writing temporary timetable in /tmp");exitseq(11);
	}
	fprintf(tblfile, userin);
	fprintf(tblfile, " ");
	fprintf(tblfile, userout);
	fprintf(tblfile, "\n");
	fclose(tblfile);
	a_b_used=1;
	return;
}


/* This function copies selections when using a timetable */
void cutfromtable(char *tablename, char *prefix)
{
	int pos2, position=1, linenumber=1;
	double number=0;

	startmins=endmins=0;
	startsecs=endsecs=0;
	negstart=negend=1;

	timefile = fopen(tablename,"rb");
	/* Load BUFFER Bytes into unsigned buffer[] */
	for (pos2=0 ; pos2<BUFFER ; pos2++) ttable[pos2]=fgetc(timefile);
	fclose(timefile);

	pos2=0;
	do
	{
		/* position: startmins=1 startsek=2 startten=3 starthun=4 */
		/*             endmins=5   endsek=6   endten=7   endhun=8 */
		number=ttable[pos2]-48;
		if (isdigit(ttable[pos2])) /* char is a digit */
		{
// 			printf(" %.2f %.2f %.2f %.2f %u \n",startmins,startsecs,endmins,endsecs,position);
			switch (position)
			{	case 1: startmins=startmins*10+ttable[pos2]-48; break;
				case 2: startsecs=startsecs*10+ttable[pos2]-48; break;
				case 3: startsecs=startsecs+number/10; position++; break;
				case 4: startsecs=startsecs+number/100; do pos2++; while (!isspace(ttable[pos2])); break;
				case 5: endmins=endmins*10+ttable[pos2]-48; break;
				case 6: endsecs=endsecs*10+ttable[pos2]-48; break;
				case 7: endsecs=endsecs+number/10; position++; break;
				case 8: endsecs=endsecs+number/100; position++; break;
				default: break;
			}
		}

		if (ttable[pos2]==45 && position < 5) negstart=-1; /* '-' is offset from end */
		if (ttable[pos2]==45 && position > 4) negend=-1;   /* '-' is offset from end */
		if (ttable[pos2]==58 && position < 5) {position=2;} /* : goes to seconds */
		if (ttable[pos2]==58 && position > 4) {position=6;} /* : goes to seconds */
		if (ttable[pos2]==46 && position==1) {position=3;} /* . goes to subseconds */
		if (ttable[pos2]==46 && position==2) {position=3;} /* . goes to subseconds */
		if (ttable[pos2]==46 && position==5) {position=7;} /* . goes to subseconds */
		if (ttable[pos2]==46 && position==6) {position=7;} /* . goes to subseconds */

		/* space switches to read end or to cutexact() */
		if (isspace(ttable[pos2]))  /* char is a whitespace */
		{
			if (position==5 && endmins+endsecs > 0)  /* only minutes given, finish */
			{
				position=9;
			}
			if (position < 5) position=5;  /* read end now */
			if (position > 4 && endmins+endsecs > 0) /* cut exact now */
			{
				if (a_b_used!=1) printf(" using timetable \"%s\" line %i:\n",tablename,linenumber);linenumber++;
// 				printf(" %.2f %.2f %.2f %.2f %u \n",startmins,startsecs,endmins,endsecs,position);
				if (negstart>0)
				{
					inpoint=seekfrombeg(startmins,startsecs);
				}
				else
				{
					inpoint=seekfromend(startmins,startsecs);
				}
				if (negend>0)
				{
					outpoint=seekfrombeg(endmins,endsecs);
				}
				else
				{
					outpoint=seekfromend(endmins,endsecs);
				}
// 				if (startmins*negstart>totalmins)
// 				{
// 					printf("  ERROR: startpoint is after end of file!  \n");
// 				}
// 				if (startmins*negstart==totalmins && startms>totalms)
// 				{
// 					printf("  ERROR: startpoint is after end of file!  \n");
// 				}
				/* end after start? -> check in cutexact() */
/*				if (startmins*60+startms>=endmins*60+endsecs && negstart==1 && negend==1)
				{
					fprintf(stdout,"  cutmts: endpoint (%li:%05.2f) must be after startpoint (%li:%05.2f)!  \n",endmins,endsecs,startmins,startms);
				}*/
				savesel(prefix); /* SAVING */
				position=1;
				startsecs=startmins=endsecs=endmins=0;
				negstart=negend=1;
				number=0;
			}
		}

		if (ttable[pos2]==255) pos2=BUFFER;
//		printf("pos2=%u %lu:%02.2f %lu:%02.2f position=%u\n",pos2,startmins,startms,endmins,endsecs,position);
		pos2++;
	}
	while (pos2<BUFFER);
}


void showfileinfo(int rawmode, int fix_channels)
{
	long double totalframes;
	unsigned char a,b,c;

	if (rawmode==1)
	{
		exitseq(0);
	}

	printf("\n\n* Properties of \"%s\":\n* \n",filename);
	printf("* Bitrate is %.0f kBit/sec\n",bitrate);
	printf("*\n* Filelength is %4.2f second(s)\n",totalms/1000);

	return;

}


void showdebug(long long seekpos, char *prefix)
{
	printf("\n\nI am at offset %li in %s\n",seekpos,filename);
	printf("Prefix is '%s'\n",prefix);
}


/* ------------------------------------------------------------------------- */
/*      */
/* MAIN */
/*      */
/* ------------------------------------------------------------------------- */

int main(int argc, char *argv[])
{
	int a,b,c,d,char1,showinfo=0,rawmode=0,fix_channels=0;
	double pos, startpos;
	double ft_factor=2;
	char *tablename=malloc(8191);
	char *prefix=malloc(8191);
	void (*play)(long long playpos) = playsel;
	char command[1023];

/* ------------------------------------------------------------------------- */
/*                   */
/* parse commandline */
/*                   */
/* ------------------------------------------------------------------------- */

	if ((fdlog = mkstemp(logname)) == -1 || (NULL== (logfile = fdopen(fdlog, "w+b"))) )
	{
		perror("\ncutmts: failed writing temporary logfile in /tmp");exitseq(11);
	}

	readconf();       /* read configuration file first! */

	if (argc<2) {usage("ERROR: missing filename");exitseq(1);}
	else
	{
		while ((char1 = getopt(argc, argv, "cCheqFf:a:b:i:o:O:I:d:D:s:")) != -1)
		{
			switch (char1)
			{
				case 'a':
					if (optarg!=0) userin=optarg;
//					else usage("Error: missing time argument");
					break;
				case 'b':
					if (optarg!=0) userout=optarg;
//					else usage("Error: missing time argument");
					break;
// 				case 'd':
// 					if (optarg!=0) card=atoi(optarg);
// 					break;
				case 'D':
					if (optarg!=0) debug=atoi(optarg);
					break;
				case 'f':
					if (NULL == (timefile = fopen(optarg,"rb") ) )
					{
						perror(optarg);
						exitseq(3);
					}
					else tablename=optarg; hastable=1;
					break;
				case 'h':
					usage("");
					exit(0);
				case 'q':
					mute=1;
					break;
				case 'i':
//					if (optarg==0) usage("Error: option requires an argument");
					if (NULL == (mtsfile = fopen(optarg,"rb") ) )
					{
						perror(optarg);
						exitseq(2);
					}
					else filename=optarg;
					break;
				case 'I':
//					if (optarg==0) usage("Error: option requires an argument");
					if (NULL == (mtsfile = fopen(optarg,"rb") ) )
					{
						perror(optarg);
						exitseq(2);
					}
					else { filename=optarg; showinfo=1; }
					break;
				case 'F':
					rawmode=1;
					break;
				case 'o':
					if (optarg!=0) snprintf(prefix,8190,optarg);
//					else usage("Error: missing outputprefix");
					forced_prefix=1;
					break;
/* ThOr: let user define exactly one output file */
				case 'O':
					if (optarg!=0)
					{
						forcedname=optarg;
						forced_file=1;
// 						if(optarg[0]=='-') stdoutwrite=1;
					}
					break;
				default:
					exitseq(1);
					break;
			}
		}
	}

	if (strlen(prefix)==0) prefix="video";

	if (userin==0 && userout!=0) usage("ERROR: missing inpoint");
	if (userin!=0 && userout==0) usage("ERROR: missing outpoint");
	if (filename==0) {usage("ERROR: missing filename, use 'cutmts -i file.mts [options]'");exitseq(1);}

	setvbuf(stdout,NULL,_IONBF,0); /* switch off buffered output to stdout when writing to file */

	mtsfile = fopen(filename, "rb");

	/* get filesize and set outpoint to it */
	fseek(mtsfile, 0, SEEK_END);
	outpoint=filesize=ftell(mtsfile);
//  printf("Filesize : %ld\n", filesize);

	/* Check beginning of file: set firstframe */
	firstframe=0;

// 	firstframe=nextframe(firstframe-1); /* in case there is invalid data after an ID3 V2 tag */

	startpos=inpoint=firstframe;

	/* get msecs at start */
	startms=getms(0);

	/* get total msecs */
	totalms=getms(filesize)-startms;

	bitrate=filesize*8/totalms*1000/1024;

//	printf("\nfirstframe=%u \n",firstframe);

	/* get filesize and set outpoint to it */
// 	snprintf(command,1022,"ffprobe -show_format %s 2>&1 | sed -n '/duration/s/.*=//p' ",filename);
// 	system(command);  /* copy excerpt */

//  printf("Filesize : %ld\n", filesize);

/********** global values: **********/

//	printf("dataend=%lu  filesize=%lu  nextframe(dataend)=%lu",dataend,filesize,nextframe(dataend));


/********** End of global part, now do specific parts **********/

	/* Show file info only? */
	if (showinfo==1)
	{
		showfileinfo(rawmode,fix_channels);
		printf("\n");
		exitseq(0);
	}

	/* -a and -b used? */
	if (userin!=0 && userout!=0)
	{
		nonint=1;
		writetable();
		cutfromtable(tblname,prefix);
 		remove(tblname);
		exitseq(0);
	}

	/* timetable used? */
	if (hastable==1)
	{
		nonint=1;
		cutfromtable(tablename,prefix);
		exitseq(0);
	}

	/*** now handle interactive mode ***/

	term_init();
	term_character();

	playfirst(firstframe);

	while (1)
	{
		printf("\n[1..0,r,a,b,s,q] > ");
//         printf("\n%3u:%05.2f [1..0,r,a,b,s,q] > ", startpos-firstframe), startpos-firstframe));
		c = getchar();
		if (c == 'q') {printf("\n\n");exitseq(0);}
		if (c == '1') {startpos=rwdsecs(startpos,1000); play(startpos);}
		if (c == '2') {startpos=rwdsecs(startpos,100); play(startpos);}
		if (c == '3') {startpos=rwdsecs(startpos,10); play(startpos);}
		if (c == '4') {startpos=rwdsecs(startpos,1); play(startpos);}
 		if (c == '5') {startpos=prevpid0(startpos); play(startpos);}
		if (c == ',') {startpos=prevframe(startpos); play(startpos);}
		if (c == '.') {startpos=nextframe(startpos); play(startpos);}    /* next frame */
		if (c == '6') {startpos=nextpid0(startpos); play(startpos);}
// 		if (c == '7') {startpos=nextxpid0(startpos,10); play(startpos);}
		if (c == '7') {startpos=skipsecs(startpos,1); play(startpos);}
		if (c == '8') {startpos=skipsecs(startpos,10); play(startpos);}
		if (c == '9') {startpos=skipsecs(startpos,100); play(startpos);}
		if (c == '0') {startpos=skipsecs(startpos,1000); play(startpos);}
		if (c == 'r') play(startpos);
		if (c == 's') {savesel(prefix);play=playsel;}
// 		if (c == 'S') writeconf();
		if (c == 'i') showfileinfo(rawmode,fix_channels);
		if (c == 'h') help();
		if (c == 'N') {howlong=howlong-1;if(howlong<10)howlong=10;printf("  playing %i units now\n",howlong);}
		if (c == 'M') {howlong=howlong+1;printf("  playing %i units now\n",howlong);}
		if (c == 'z') showdebug(startpos,prefix);
		if (c == 'a')
		{
			inpoint=startpos;
			printf("  startpoint set to %.1f s \n",(getms(inpoint)-startms)/1000);
			play=playsel;
		}
		if (c == 'b')
		{
			outpoint=startpos;
			printf("  endpoint set to %.1f s \n",(getms(outpoint)-startms)/1000);
			play=playsel;
		}
		if (c == 'o')
		{
			overwrite=1-overwrite;
			if (1-overwrite) printf("  overwrite off\n");
			else printf("  overwrite on (for next time only)\n");
		}
		if (c == 'm')
		{
			mute=1-mute;
			if (1-mute) printf("  mute off\n");
			else printf("  muted\n");
		}
		if (c == 'w')
		{
			outpoint=startpos;printf("  endpoint set to %.1f s \n",(getms(outpoint)-startms)/1000);
			savesel(prefix);
			inpoint=startpos;printf("  startpoint set to %.1f s \n",(getms(inpoint)-startms)/1000);
		}
		if (c == 'A')
		{
			startpos=inpoint;
			play(startpos);
		}
		if (c == 'B')
		{
			startpos=outpoint;
			play(startpos);
		}
	}
	exitseq(0);
}


/*

MTS-Header: 4 Bytes
davor immer 4 Bytes Timestamp

########
0 - 7   Dezimal 71
########
    8   Transport Error Indicator
    9   Payload Unit Start Indicator
   10   Transport Priority
11-23   PID
########
24-25   Scrambling control
   26   Adaptation field exist <----- see below
   27   Contains payload
28-31   Continuity counter
########


---- Adaptation Field Format ----
0-7 Adaptation Field Length
	Number of bytes in the adaptation field immediately following this byte
8 	Discontinuity indicator
	Set to 1 if current TS packet is in a discontinuity state with respect to either the continuity counter or the program clock reference
9	Random Access indicator <-----------------
	Set to 1 if the PES packet in this TS packet starts a video/audio sequence
10	Elementary stream priority indicator
11	PCR flag <-----------------
	Set to 1 if adaptation field contains a PCR field
12	OPCR flag <-----------------
	Set to 1 if adaptation field contains an OPCR field
13	Splicing point flag
	Set to 1 if adaptation field contains a splice countdown field
14	Transport private data flag
	Set to 1 if adaptation field contains private data bytes
15	Adaptation field extension flag
	Set to 1 if adaptation field contains an extension
---- Below fields are optional
33+6+9 bits	PCR <-----------------
			Program clock reference, stored in 6 octets in big-endian as 33 bits base, 6 bits padding, 9 bits extension.
33+6+9 bits	OPCR <-----------------
			Original Program clock reference. Helps when one TS is copied into another
8 bits		Splice countdown
			Indicates how many TS packets from this one a splicing point occurs (may be negative)
variable stuffing bytes



Just look for transport packets with payload start indicator and collect the payload (a PES packet) from there.
You have to find the random access points (I frames with a sequence header or SPS) yourself or you use the
clipinfo file if it is available.

Yeah ... meanwhile it looks like ignoring the timestamp is what most stream analyzers do :)
Now I decided to do likewise and browse for the packets first to analyze my streams for PAT, PMT, and ES.
I got distracted by the timestamp and misunderstood that as information that would help me with the random access.

*/

/*
Transport Stream had been originally designed for broadcast. Later it was
adapted for usage with digital video cameras, recorders and players by adding a
4-byte timecode (TC) to standard 188-byte packets, which resulted in a 192-byte
packet.[12][13] This is what is informally called M2TS stream. Blu-ray Disc
Association calls it "BDAV MPEG-2 transport stream".[12] JVC called it TOD
(possibly an abbreviation for "Transport stream on disc") when used in HDD-based
camcorders like GZ-HD7.[14][15] The timecode allows quick access to any part of
the stream either from a media player, or from a non-linear video editing
system.[16] It is also used to synchronize video streams from several cameras in
a multi-camera shoot.
*/

/*
AVCHD speichert das/die Aufnahme/Datum/Uhrzeit und vieles mehr als SEI
(Supplemental enhancement information) Messages im MTS Stream (Sony z.b mit
jedem 12ten Frame).
Diese MDPM Info findet sich als "user_data_unregistered" mit der UUID
0x17EE8C60F84D11D98CD60800200C9A66. Datum und Uhrzeit sind dort BCD kodiert in
Tag 18 und 19 hinterlegt.
*/
